]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: Delegate with option `nospace`
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60 if test -n "$BASH_VERSION"; then
61    [ "`type -t ls`" = alias ] && unalias ls
62    [ "`type -t ll`" = alias ] && unalias ll
63    [ "`type -t mc`" = alias ] && unalias mc
64
65    back() { cd - "$@"; }
66    functions() { typeset -f "$@"; }
67    j() { jobs; }
68
69    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
70       if [ -d /usr/share/bash-completion -a -r /usr/share/bash-completion/bash_completion ]; then
71          _BASH_COMPLETIONS_DIR=/usr/share/bash-completion/completions
72          . /usr/share/bash-completion/bash_completion
73       elif [ -r /etc/bash_completion ]; then
74          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
75          . /etc/bash_completion
76       elif [ -d /etc/bash_completion.d ]; then
77          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
78          for _compf in /etc/bash_completion.d/*; do
79             . $_compf
80          done
81       elif [ -d /usr/local/etc/bash_completion.d ]; then
82          _BASH_COMPLETIONS_DIR=/usr/local/etc/bash_completion.d
83          for _compf in /usr/local/etc/bash_completion.d/*; do
84             . $_compf
85          done
86       else
87          echo "Unknown OS type, cannot source bash_completion" >&2
88       fi
89    fi
90
91    has_completion() {
92       [ -n "$_BASH_COMPLETIONS_DIR" -a -d "$_BASH_COMPLETIONS_DIR" -a -r "$_BASH_COMPLETIONS_DIR/$1" ] ||
93       complete -p $1 >/dev/null 2>&1
94    }
95
96    for cmd in builtin cgmem_nice command dbus-launch exec \
97          killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg \
98          run-hosts su sudo time whence whereis which xargs; do
99       ! has_completion $cmd && complete -o default -A command $cmd
100    done
101
102    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 \
103          ssh2 s2 socat telnet t tt \
104          tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
105          whois wd wget wget-download wget-m wget-wrapper ww; do
106       ! has_completion $cmd && complete -A hostname $cmd
107    done
108
109    for cmd in distribute ftp lftp r rsync \
110          s scp ssh smbclient tcpdump tshark wireshark; do
111       ! has_completion $cmd && complete -o default -A hostname $cmd
112    done
113
114    for cmd in bg fg jobs; do
115       ! has_completion $cmd && complete -A job $cmd
116    done
117
118    complete -A job j wait
119
120    for cmd in unset; do
121       ! has_completion $cmd && complete -A function -A variable $cmd
122    done
123
124    if [ -d "$HOME"/.bash_completion.d ]; then
125       for _compf in "$HOME"/.bash_completion.d/*; do
126          . $_compf
127       done
128    fi
129
130    delegate_completion() {
131       local prog programs
132       prog=$1
133       ! has_completion $prog && return
134       shift
135       programs="$@"
136       eval "_${prog}_completion_loader() {
137          _completion_loader $prog
138          if [ x"$DELEGARE_NOSPACE" = x1 ]; then
139             complete -o nospace -F _$prog $programs
140          else
141             complete -F _$prog $programs
142          fi
143          unset _${prog}_completion_loader
144          return 124
145       }"
146       complete -F _${prog}_completion_loader $programs
147    }
148
149    delegate_completion make m
150    delegate_completion ping p
151    delegate_completion python python2.7 python3.4 python3.5 python3.6 python3.7 python3.8 python3.9
152    DELEGARE_NOSPACE=1 delegate_completion rsync r rsync_cgmn rsync_cgmn_recode rsync_cgmn_recode2
153    delegate_completion ssh s
154    delegate_completion wget wget-m wget-wrapper ww
155
156    unset _BASH_COMPLETIONS_DIR has_completion delegate_completion
157
158    if [ -d "$HOME/lib/config" ]; then
159       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
160    fi
161    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
162
163    if [ "`type -t short_curdir`" != function -a \
164          -r "$HOME"/admin/prog/bash_prompt ]; then
165       . "$HOME"/admin/prog/bash_prompt
166    fi
167
168    #if type -p pip >/dev/null 2>&1; then
169    #   eval "`pip completion --bash`"
170    #fi
171
172    #if which pyenv >/dev/null 2>&1; then
173    #   eval "`pyenv init -`"
174    #   eval "`pyenv virtualenv-init -`"
175    #fi
176
177    . virtualenvwrapper_lazy.sh 2>/dev/null
178
179    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
180       . "$VIRTUAL_ENV/bin/activate"
181    fi
182
183    # Clean up python virtual environment on exit
184    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
185
186    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
187
188 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
189    back() { cd - "$@"; }
190    j() { jobs; }
191 fi
192
193 PS1="$OPS1"
194
195 # clear screen and history, logout
196 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
197
198
199 if test -x /usr/bin/git >/dev/null 2>&1; then
200    # chdir to a directory
201    cdgitpath() {
202       if [ $# -ne 1 ]; then
203          echo "Usage: cdgitpath path_key" >&2
204          return 1
205       fi
206
207       path_key="$1"
208       if [ -z "$path_key" ]; then
209          echo "Usage: cdgitpath path_key" >&2
210          return 1
211       fi
212
213       path_url="`git config --get --path $path_key`"
214       if echo "$path_url" | grep -q '^file:/'; then
215          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
216       fi
217       cd "$path_url"
218    }
219
220    # chdir to a remote's directory (if the remote is on the local FS)
221    cdremote() {
222       if [ $# -gt 1 ]; then
223          echo "Usage: cdremote [remote_name]" >&2
224          return 1
225       fi
226
227       if [ -z "$1" ]; then
228          branch="`git rev-parse --abbrev-ref HEAD`"
229          remote="`git config --get branch.$branch.remote`"
230       else
231          remote="$1"
232       fi
233
234       if [ -n "$remote" ] && git config --get remote.$remote.url |
235             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
236          cdgitpath remote.$remote.url
237       else
238
239          if [ -n "$1" ]; then
240             echo "Cannot find directory for remote $1" >&2
241             echo "Usage: cdremote [remote_name]" >&2
242             return 1
243          fi
244
245          if test -n "$BASH_VERSION"; then
246             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
247             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
248                remote=${GIT_REMOTES[0]}
249                unset GIT_REMOTES
250                cdgitpath remote.$remote.url
251             else
252                unset GIT_REMOTES
253                echo "Cannot find directory for any remote" >&2
254                echo "Usage: cdremote [remote_name]" >&2
255                return 1
256             fi
257          else
258             echo "Cannot find directory for remote $1" >&2
259             echo "Usage: cdremote [remote_name]" >&2
260             return 1
261          fi
262       fi
263    }
264
265    if test -n "$BASH_VERSION"; then
266       # completion for aliases in global .gitconfig
267
268       # fixup rbi rbia rbiap rbip - do refs name completion
269       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
270       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
271       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
272       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
273       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
274       #
275       # push-to-all-remotes - do branch name completion
276       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
277
278       _cdgitpath_complete() {
279          local cur="${COMP_WORDS[COMP_CWORD]}"
280          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
281       }
282
283       _git_open() {
284          _cdgitpath_complete
285       }
286
287       complete -F _cdgitpath_complete cdgitpath git-open
288
289       # list remotes with URLs matching a regexp
290       _list_remotes() {
291          if [ $# -ne 1 ]; then
292             echo "Usage: _list_remotes remote_regexp" >&2
293             return 1
294          fi
295          declare -ag GIT_REMOTES=()
296          local remote
297          for remote in `git remote`; do
298             if git config --get remote.$remote.url | grep -q "$1"; then
299                GIT_REMOTES+=($remote)
300             fi
301          done
302       }
303
304       # completion for cdremote and git-open-remote - list remotes with a pattern
305       _list_remotes_completion() {
306          local cur="${COMP_WORDS[COMP_CWORD]}"
307          _list_remotes "$1"
308          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
309          unset GIT_REMOTES
310       }
311
312       # completion for cdremote - list remotes with directories as URLs
313       _cdremote_complete() {
314          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
315          if [ ${#COMPREPLY[*]} -eq 0 ]; then
316             _list_remotes_completion .
317          fi
318       }
319
320       complete -F _cdremote_complete cdremote
321
322       # completion for git-open-remote - list remotes with http(s) URLs
323       _git_open_remote() {
324          _list_remotes_completion '^http\(s\)\?://'
325          if [ ${#COMPREPLY[*]} -eq 0 ]; then
326             _list_remotes_completion .
327          fi
328       }
329
330       complete -F _git_open_remote git-open-remote
331    fi
332 fi
333
334
335 include() {
336    cfg="$1"
337    shift
338    if [ -f "./$cfg" -a -r "./$cfg" ]; then
339       echo "Reading config file \`$cfg'" 1>&2
340       . "./$cfg" "$@"
341    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
342       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
343       . "$HOME/lib/config/$cfg" "$@"
344    else
345       echo "Cannot find config file \`$cfg'" 1>&2
346    fi
347 }
348
349
350 mc() {
351    if test -n "$BASH_VERSION"; then
352       MC_SAVE_OPS1="$OPS1"
353       if [ "`type -t short_curdir`" = function ]; then
354          OPS1="\`cgmem_which_prompt\`\u@\${HOSTNAME::5}:\`short_curdir\`"
355          if test -x /usr/bin/git >/dev/null 2>&1; then
356             #if [ "`type -t __git_ps1`" = function ]; then
357             #   OPS1+="\$(__git_ps1)"
358             #else
359                OPS1+="\$(prompt_git)"
360             #fi
361          fi
362          OPS1+=" \$SHLVL\\$ "
363       else
364          OPS1="\u@\h:\W \$SHLVL\\$ "
365       fi
366    fi
367
368    if [ -n "$SLOWTERM" ]; then
369       MC_SLOW="--slow"
370    fi
371
372    case "$TERM" in
373       screen*) # screen, screen.rxvt
374          MC_XTERM="-x"
375       ;;
376    esac
377
378    #TMPDIR="$HOME"/tmp
379    #export TMPDIR
380
381    MC_FOUND=NO
382
383    for wrapper in \
384          /usr/local/share/mc/bin/mc-wrapper.sh \
385          /usr/local/libexec/mc/mc-wrapper.sh \
386          /usr/share/mc/bin/mc-wrapper.sh; do
387       if [ -r $wrapper ]; then
388          . $wrapper $MC_SLOW $MC_XTERM "$@"
389          rc=$?
390          MC_FOUND=YES
391          break
392       fi
393    done
394
395    if [ $MC_FOUND = NO ]; then
396       for mc in /usr/local/bin/mc /usr/bin/mc; do
397          if [ -x $mc ]; then
398             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
399             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
400                MC_TMP_DIR="${TMPDIR-/tmp}"
401             fi
402             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
403             mc_type="`mc_type.py $mc`"
404             if [ "$mc_type" = old ]; then
405                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
406             elif [ "$mc_type" = new ]; then
407                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
408             else
409                continue
410             fi
411             rc=$?
412             MC_FOUND=YES
413             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
414             break
415          fi
416       done
417    fi
418
419    if [ $MC_FOUND = NO ]; then
420       echo "Cannot find mc-wrapper.sh or mc" >&2
421       rc=1
422    fi
423
424    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
425    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
426
427    return $rc
428 }
429
430
431 mkcd() {
432    if [ $# -ne 1 ]; then
433       echo "Usage: mkcd directory_name" >&2
434    elif [ -d "$1" ]; then
435       cd "$1"
436    elif [ -e "$1" ]; then
437       echo "Error: $1 is a file" >&2
438    else
439       mkdir -p "$1" && cd "$1"
440    fi
441 }
442
443
444 if which tmux >/dev/null 2>&1; then
445    tmux() {
446       case "$TERM" in
447          rxvt)
448             TERM=rxvt-unicode command tmux "$@"
449          ;;
450
451          *)
452             command tmux "$@"
453          ;;
454       esac
455    }
456 fi
457
458
459 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
460    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
461 fi
462
463 x() { exit; }